%close all; clear; clc;
disp("------------------------------------------------------------------");
disp("Analyse Data");
disp("------------------------------------------------------------------");

% Change this for using XSR log files 

isXSR = true;

if( isXSR )
    data = importfile_XSR('log_20230928_111452_bugOscillationStopC.csv');
else
    data = importfile('log_20230928_111452_bugOscillationStopC.csv');
end


targetPosition  = "targetposition";

axisNames       = { "x", "y", "z", "b", "c" };

fieldNnames     = targetPosition + axisNames;

[N, M]  = size(data.Variables);
dt      = 1e-3;

time    = [ 0 : dt : (N -1)* dt ];

%% Sampler results : Independant axis

figure('Name', 'Sampler results : position');
count   = 0;

for f_ = fieldNnames
    count = count + 1;
    subplot( 5, 1, count );
    plot( time, data.(f_)); grid on;
    ylabel( "Axis " + axisNames{ count }, 'FontSize', 15 );
    if( count == 1 ), title("Sampler Results : Position", 'FontSize', 21); end
end

xlabel( "Time [s]", 'FontSize', 21 );

figure('Name', 'Sampler results : velocity');
count   = 0;

for f_ = fieldNnames
    count = count + 1;
    subplot( 5, 1, count );
    plot( time(2 : end ), diff( data.(f_) ) / dt); grid on;
    ylabel( "Axis " + axisNames{ count }, 'FontSize', 15 );
    if( count == 1 ), title("Sampler Results : Velocity", 'FontSize', 21); end
end

xlabel( "Time [s]", 'FontSize', 21 );

figure('Name', 'Sampler results : acceleration');
count   = 0;

for f_ = fieldNnames
    count = count + 1;
    subplot( 5, 1, count );
    plot( time(3 : end ), diff( diff( data.(f_) )) / dt^2); grid on;
    ylabel( "Axis " + axisNames{ count }, 'FontSize', 15 );
    if( count == 1 ), title("Sampler Results : Acceleration", 'FontSize', 21); end
end

xlabel( "Time [s]", 'FontSize', 21 );

function data = importfile(filename, dataLines)
%IMPORTFILE Import data from a text file
%  LOGTESTG57CLEARANCE120230906171448 = IMPORTFILE(FILENAME) reads data
%  from text file FILENAME for the default selection.  Returns the data
%  as a table.
%
%  LOGTESTG57CLEARANCE120230906171448 = IMPORTFILE(FILE, DATALINES)
%  reads data for the specified row interval(s) of text file FILENAME.
%  Specify DATALINES as a positive scalar integer or a N-by-2 array of
%  positive scalar integers for dis-contiguous row intervals.
%
%  Example:
%  logtestG57clearance120230906171448 = importfile("/home/hugo/Documents/E2C/opencn/agency/usr/matlab/common/Bugs/AxisNotFollowingGcode/log_test_G57_clearance_1_20230906_171448.csv", [1, Inf]);
%
%  See also READTABLE.
%
% Auto-generated by MATLAB on 07-Sep-2023 08:38:09

%% Input handling

% If dataLines is not specified, define defaults
if nargin < 2
    dataLines = [1, Inf];
end

%% Set up the Import Options and import the data
opts = delimitedTextImportOptions("NumVariables", 17);

% Specify range and delimiter
opts.DataLines = dataLines;
opts.Delimiter = " ";

% Specify column names and types
opts.VariableNames = ["targetpositionx", "targetpositiony", "targetpositionz", "targetpositionb", "targetpositionc", "currentposX", "currentposY", "currentposZ", "currentposB", "currentposC", "poserror0", "poserror1", "poserror2", "poserror3", "poserror4", "dataselector", "machiningfinished"];
opts.VariableTypes = ["double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double"];

% Specify file level properties
opts.ExtraColumnsRule = "ignore";
opts.EmptyLineRule = "read";
opts.ConsecutiveDelimitersRule = "join";
opts.LeadingDelimitersRule = "ignore";

% Specify variable properties
opts = setvaropts(opts, ["targetpositionx", "targetpositiony", "targetpositionz", "targetpositionb", "targetpositionc", "currentposX", "currentposY", "currentposZ", "currentposB", "currentposC", "poserror0", "poserror1", "poserror2", "poserror3", "poserror4", "dataselector", "machiningfinished"], "ThousandsSeparator", ",");

% Import the data
data = readtable(filename, opts);

end

function data = importfile_XSR(filename, dataLines)
%IMPORTFILE Import data from a text file
%  LOGTESTG57CLEARANCE120230907103105XSR = IMPORTFILE(FILENAME) reads
%  data from text file FILENAME for the default selection.  Returns the
%  data as a table.
%
%  LOGTESTG57CLEARANCE120230907103105XSR = IMPORTFILE(FILE, DATALINES)
%  reads data for the specified row interval(s) of text file FILENAME.
%  Specify DATALINES as a positive scalar integer or a N-by-2 array of
%  positive scalar integers for dis-contiguous row intervals.
%
%  Example:
%  logtestG57clearance120230907103105XSR = importfile("/home/hugo/Documents/E2C/opencn/agency/usr/matlab/common/Bugs/AxisNotFollowingGcode/log_test_G57_clearance_1_20230907_103105_XSR.csv", [1, Inf]);
%
%  See also READTABLE.
%
% Auto-generated by MATLAB on 07-Sep-2023 11:50:12

%% Input handling

% If dataLines is not specified, define defaults
if nargin < 2
    dataLines = [1, Inf];
end

%% Set up the Import Options and import the data
opts = delimitedTextImportOptions("NumVariables", 61);

% Specify range and delimiter
opts.DataLines = dataLines;
opts.Delimiter = " ";

% Specify column names and types
opts.VariableNames = ["num", "targetpositionx", "targetpositiony", "targetpositionz", "targetpositionb", "targetpositionc", "currentposX", "currentposY", "currentposZ", "currentposB", "currentposC", "poserror0", "poserror1", "poserror2", "poserror3", "poserror4", "dataselector", "machiningfinished", "Var19", "Var20", "Var21", "Var22", "Var23", "Var24", "Var25", "Var26", "Var27", "Var28", "Var29", "Var30", "Var31", "Var32", "Var33", "Var34", "Var35", "Var36", "Var37", "Var38", "Var39", "Var40", "Var41", "Var42", "Var43", "Var44", "Var45", "Var46", "Var47", "Var48", "Var49", "Var50", "Var51", "Var52", "Var53", "Var54", "Var55", "Var56", "Var57", "Var58", "Var59", "Var60", "Var61"];
opts.SelectedVariableNames = ["num", "targetpositionx", "targetpositiony", "targetpositionz", "targetpositionb", "targetpositionc", "currentposX", "currentposY", "currentposZ", "currentposB", "currentposC", "poserror0", "poserror1", "poserror2", "poserror3", "poserror4", "dataselector", "machiningfinished"];
opts.VariableTypes = ["double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "string", "string", "string", "string", "string", "string", "string", "string", "string", "string", "string", "string", "string", "string", "string", "string", "string", "string", "string", "string", "string", "string", "string", "string", "string", "string", "string", "string", "string", "string", "string", "string", "string", "string", "string", "string", "string", "string", "string", "string", "string", "string", "string"];

% Specify file level properties
opts.ExtraColumnsRule = "ignore";
opts.EmptyLineRule = "read";
opts.LeadingDelimitersRule = "ignore";

% Specify variable properties
opts = setvaropts(opts, ["Var19", "Var20", "Var21", "Var22", "Var23", "Var24", "Var25", "Var26", "Var27", "Var28", "Var29", "Var30", "Var31", "Var32", "Var33", "Var34", "Var35", "Var36", "Var37", "Var38", "Var39", "Var40", "Var41", "Var42", "Var43", "Var44", "Var45", "Var46", "Var47", "Var48", "Var49", "Var50", "Var51", "Var52", "Var53", "Var54", "Var55", "Var56", "Var57", "Var58", "Var59", "Var60", "Var61"], "WhitespaceRule", "preserve");
opts = setvaropts(opts, ["Var19", "Var20", "Var21", "Var22", "Var23", "Var24", "Var25", "Var26", "Var27", "Var28", "Var29", "Var30", "Var31", "Var32", "Var33", "Var34", "Var35", "Var36", "Var37", "Var38", "Var39", "Var40", "Var41", "Var42", "Var43", "Var44", "Var45", "Var46", "Var47", "Var48", "Var49", "Var50", "Var51", "Var52", "Var53", "Var54", "Var55", "Var56", "Var57", "Var58", "Var59", "Var60", "Var61"], "EmptyFieldRule", "auto");

% Import the data
data = readtable(filename, opts);

end